# Modern Applied Biostatistical Methods Using S-PLUS
# S. Selvin, Oxford, 1998
#
# Chapter 1: S-language
#
# Time-stamp: <2008-03-21 20:43:20 chl>

##############################################################################
# Note to the R user:
# I suppress incompatible S-expressions, like the use of "_" for
# affectation.
##############################################################################

x <- 10
10 -> x
x
x+100
x^2

x <- c(10,20,30,40)
x

x+100
x^2

ctemp <- c(1,2,3,4,5,6,7,8,9)
c(ctemp,ctemp,ctemp)
c(0,ctemp,10)

c1 <- c(10,20,30,40)
c2 <- c(5,10,15,20)

x <- cbind(c1,c2)
x

x+100

x^2

rbind(c1,c2)

0:10
temp <- 1:9
temp
20:8
c(1:5,5:1,1:5)
rbind(1:6,11:16,111:116)

darray <- matrix(1:12,3,4)
darray

array0 <- matrix(1:12,6)
array0

darray[2,2]

darray[2,]
darray[,3]

cell12 <- darray[1,2]
cell12
row2 <- darray[2,]
row2
row2+10
row2^2
c(row2,row2^2,row2^3)

matrix(1,3,5)

data <- scan("test.file")
data

data <- scan()
data

temp <- scan("test.file")
d0 <- matrix(temp,3,3)
d0

d0 <- matrix(scan("test.file"),3,3)

d0 <- matrix(scan("test.file"),3,byrow=F)
d0

d0 <- matrix(scan("test.file"),3,byrow=T)
d0

rep(0,times=10)
rep(0,10)
rep(c(3,2,1),5)
rep(c(3,2,1),c(1,2,3))
rep(1:4,c(2,4,6,8))

1:8
seq(8)
seq(1,8,1)
seq(0,10,2)
seq(from=0,to=1,by=0.1)
seq(0,1,by=0.1)
seq(0,1,0.1)
seq(0,1,0.2)
seq(0,1,length=5)
seq(0,1,length=12)
seq(20,2,-4)
20:8
seq(20,8,-1)

z <- c(1,2,3,4,5,6,5,4,3,2,1)
z
e[c(1,3,5,7,9)]
z[7]
z[c(2,4,6,8)]
z[1:5]
z[7:10]
z[seq(1,10,2)]
z[rep(9,6)]
seq(1,10,length=4)
z[seq(1,10,length=4)]

z[c(3,9,1,7,5)]

rep(c(3,9,1,7,5),3)
z[rep(c(3,9,1,7,5),3)]

z <- z[c(1,3,5,7,9,2,4,6,8,11,10)]
z

z[-6]
z[-c(2,4,6,8)]
z[-seq(1,10,2)]
z[c(-4,-7,-11,-1,-6)]

z[z<3]
z[z<3 & z>=6]

z<3
z>=4
z<3 | z>4
z<3 | z<6
z<3 & z<6
(z<3 | z<6) | (z<3 & z<6)

znew <- z[z<3]
znew
enwe+znew^2

z
z[z<3]
(1:11)[z>=4]
z[z<3 | z>4]
z[z<3 | z<6]
z[z<3 & z<6]
z[(z<3 | z<6) | (z<3 & z<6)]
z[(z<3 | z>4) & z!=2]

z==3
z[z==3]
z!=3
z[z!=3]
(!z==3)
z[!z==3]
z==5
(z==3 | z==5)
z[(z==3 | z==5)]
(!(z==3 | z==5))
z[!(z==3 | z==5)]

a <- c(4,1,3,2,4,3,2,1,1,2,3)
b <- c(10,200,500,1000)
b[a]

s <- c(1,2,3,NA,5,6,5,NA,3,2,1)
is.na(s)
(!is.na(s))
s[!is.na(s)]

d <- 1:10
length(d)
length(seq(1,32,4))
length(rep(1:7,1:7))

length(d)/2
id <- c(rep(0,length(d)/2),rep(1,length(d)/2))
id

id==0
ifelse(id==0,2*d,d/2)
d>=4
ifelse(d>=4,1,0)
d<=4
ifelse(d<=4,d+1,0)
(id==1 & d<7 | d>8)
ifelse(id==1 & d<7 | d>8,1,0)

ifelse((id==1 & d<7) | (d>8),1,0)

x <- c(-1,0,1,2,3,4)
abs(x)
exp(x)
log(x)
log10(x)
sqrt(x)
sign(x)
gamma(x)

gamma(5)
gamma((1:9)+1)

log(1:6)/log10(1:6)
exp(seq(0,1,0.2))
sin(seq(0,2*pi,1))
sqrt(exp(log(abs(x))))
test <- c(0,pi/2,pi,3*pi/2)
test
sin(test)
asin(sin(test))

help(pi)

7+4

fact <- 12.4/3
fact

(1000-(7+4)/3*4)^2

a <- 3
b <- 12
b/a
2*b-a^2+(b-a)^2

x <- seq(-2,2,1)
p <- (1+sqrt(1-exp(-2*x^2/pi)))/2
p

y <- c(0.234,1.561,5.320,0.053,3.333,7.688,7.688,2.116,5.72,9.321,0.844)
y

prod(y)

cumsum(y)

diff(y)

length(diff(y))
length(y)

prod(1:10)
prod(1:10)/(prod(1:7)*prod(1:3))
cumsum(y)/(1:length(y))
prod(diff(y))
exp(cumsum(log(y)))
cumprod(y)
exp(diff(log(1:10)))

round(y)
round(y,0)
round(y,1)
round(y,2)

trunc(y)
ceiling(y)

sort(y)
rev(sort(y))

rev(1:12)

rank(y)

order(y)

y[order(y)]

sort(y)[1]
order(y)[1]
y[order(y)[1]]
sort(y)[10]
order(y)[10]
y[order(y)[length(y)]]

k <- 5
yord <- order(y)
yord[1:k]
y[yord[1:k]]
m <- (length(y)-(k-1)):length(y)
yord[m]
y[yord[m]]

r1 <- c(4,0,22)
r2 <- c(9,1,38)
r3 <- c(1,0,61)
r4 <- c(3,1,11)
m0 <- rbind(r1,r2,r3,r4)
m0
temp0 <- order(m0[,1])
temp0
m0[temp0,]

x <- seq(0,5,0.001)
fx <- x^3-8*x-20
m <- order(fx)
m[1]
fx[m[1]]
x[m[1]]

g <- 1:12
g%%2
g%%4
g[g%%4==0]
g[g%%4!=0]

g-4*trunc(g/4)
g%%4

g%%2==0
g[g%%2==0]
g[g%%2!=0]
ifelse(g%%2==0,0,1)

x <- c(14,1,8,3,4,4,5,5,5,6,7,2,1)
x
sum(x)
sum(x^2)

mean(x)
mean(x-5)
median(x)

min(x)
max(x)

var(x)
### - R --
### S <- sd(x)
S <- sqrt(var(x))
S

r <- range(x)
r
r[2]-r[1]
diff(range(x))

(x-mean(x))/sqrt(var(x))
sum((x-mean(x))/sqrt(var(x)))
var((x-mean(x))/sqrt(var(x)))
range(sum((x-mean(x))/sqrt(var(x))))
sum((x-mean(x))^2)/(length(x)-1)
var(x[x<=4])/var(x[x>4])

quantile(x,0.5)
median(x)
quantile(x,0.75)
quantile(x)
quantile(0:100,0.95)
quantile(0:1000,seq(0,1,0.1))

q <- quantile(x,c(0.25,0.75))
q

q[2]-q[1]
diff(q)

cor(x,1/x)
cor(x,sqrt(x))

x0 <- c(1,2,0,0,2,1)
y0 <- c(1,2,3,3,2,1)
z0 <- c(2,1,0,0,1,2)
xyz <- cbind(x0,y0,z0)
xyz
var(xyz)

cor(xyz)

xx <- c(1,1,2,4,NA,2,4,1,3)
mean(xx)
mean(xx,na.rm=T)
var(xx,na.rm=T)
mean(xx[!is.na(xx)])
var(xx[!is.na(xx)])

x <- 1.0
pnorm(x)
pnorm(1.96)
pnorm(1.644854)
pnorm(c(-0.5,0.5))
pnorm(seq(-2,2,1))

pnorm(2,0,2)
pnorm(c(-3,5,13),5,4)
pnorm(1:5,3,1.5)
z <- (1:5-3)/1.5
pnorm(z)

p <- 0.8
qnorm(p)
qnorm(0.9750021)
qnorm(0.95)
qnorm(c(0.3,0.7))
qnorm(c(0.9,0.95,0.975,0.99))

pnorm(qnorm(c(0.9,0.95,0.975,0.99)))

dnorm(0)

dnorm(c(-2,-1,0,1,2))
dnorm(qnorm(c(0.05,0.95)))
dnorm(c(-2,-1,0,1,2),2,2)

rnorm(10)

rnorm(10,12,3)

mean(rnorm(1000))
median(rnorm(1000))
range(rnorm(1000))
var(rnorm(1000))
quantile(rnorm(1000),c(0.05,0.1,0.5,0.90,0.95))
qnorm(c(0.05,0.1,0.5,0.90,0.95))

runif(12)

10*runif(12)

runif(12,0,10)

ceiling(10*runif(12))
ceiling(runif(12,0,10))

sum(ifelse(runif(100)<0.5,1,0))
sum(ifelse(runif(100)<0.6,1,0))

a <- rbind(c(1,2,3),c(2,3,2),c(3,2,1))
a
apply(a,1,sum)
apply(a,2,mean)
apply(a,2,var)
apply(a,1,prod)
apply(a,1,function(x){sum((x-mean(x))^2)})
apply(a,2,function(x){prod(x)^(1/length(x))})

data <- ceiling(10*runif(100))
table(data)
table(ifelse(runif(300)<0.6,1,0))

x <- c(rep(0,3),rep(1,4),rep(2,4),rep(3,6),rep(4,3))
x
y <- rep(c(1,0),10)
y
tab <- table(y,x)

sum(tab)
prod(tab)
length(tab)
tab*tab

tab[2,3]
tab[,3]
tab/2
(tab-4)/2

apply(tab,1,sum)
apply(tab,2,sum)
apply(tab,1,mean)
apply(tab,2,mean)

x <- rnorm(100)
cut(x,c(-9,-2,-1,0,1,2,9))

u <- runif(100)
cut(u,10)
table(cut(u,10))

deciles <- c("1st","2nd","3rd","4th","5th","6th","7th","8th","9th","10th")
table(cut(u,10,labels=deciles))

y <- x+rnorm(100)
table(cut(x,c(-9,-2,-1,0,1,2,9)),cut(y,c(-9,-1,0,1,9)))

n <- 100
u <- runif(n)
cc <- cut(u,seq(0,1,length=4),labels=c("low","medium","high"))
table(cc)
tapply(u,cc,length)
tapply(u,cc,mean)
tapply(u,cc,var)

x <- 0:999
f1 <- ifelse(x%%2,1,0)
f2 <- ifelse(x%%9,1,0)
table(f1,f2)
tapply(x,list(f1,f2),length)
tapply(x,list(f1,f2),mean)
tapply(x,list(f1,f2),median)
### - R --
### tapply(x,list(f1,f2),sd)
sqrt(tapply(x,list(f1,f2),var))

array(c(1:10,101:110,1001:1010),c(2,5,3))
array(1:24,c(3,8))
matrix(1:24,3,8)
mtemp <- matrix(1:24,3,8)
mtemp
array(mtemp)

m <- matrix(1:36,9,4)
m
nrow(m)
ncol(m)
dim(m)
length(dim(m))

diag(m)

k <- 6
diag(k)
diag(1:3)

m[2,3]
m[,3]
m[3,]
m[,-3]

m[3:8,2:4]
m[-(3:8),2:4]

t(m[3:8,2:4])

x <- c(1,2,3)
y <- c(3,0,1)
x*y
x%*%y
crossprod(x,y)
a <- rbind(c(1,2,3),c(2,3,2),c(3,2,1))
a
a*a
a%*%a
a/a
a*x
a%*%x

solve(a)

round(solve(a)%*%a,2)

a
y
z <- solve(a,y)
z
z%*%a

x
y
outer(x,y)

outer(x,y,"+")
outer(x,y,"^")
outer(x,y,function(x,y){(1+x^2)/(1+y^2)})

counts <- c(0,0,0,0)
n <- c(2,4,6,4)
for (i in 1:length(n)) {
  counts <- c(counts,rep(i,n[i]))
}
counts

counts <- rep(0:4,c(4,2,4,6,4))
counts

n <- 15
f <- NULL
r <- NULL
f[1] <- 1
f[2] <- 2
for (i in 1:(n-2)) { f[i+2] <- f[i+1]+f[i] }
f
for (i in 1:(n-1)) { r[i] <- f[i+1]/f[i] }
round(r,3)
r <- exp(diff(log(f)))
round(r,3)

y <- NULL
k <- 0
x <- c(1,0,2,0,3,0,4,0,5,0,6,-1,0,6,0,5,0,4,0,3,0,2,0,1)
for (i in 1:length(x)) {
  if (x[i]==0) next
  if (x[i]<0) break
  k <- k+1
  y[k] <- 1/x[i]
}
y

s <- NULL
for (i in 1:k) { s[i] <- sum(rnorm(n,10,2)) }
s <- apply(matrix(rnorm(n*k,10,2),n,k),2,sum)

f <- function(x) { x^3+x^2+x+10 }
x <- 1:6
f(x)
f(2*x)
f(x/2)

devf <- function(x) { (f(x+0.001)-f(x))/0.001 }
devf(2.5)
devf(c(10,1.8,5,13))
round(devf(x),3)
round(3*x^2+2*x+1,3)

cov <- function(x,y) { sqrt(var(x)*var(y))*cor(x,y) }
x0 <- c(1,2,0,0,2,1)
y0 <- c(1,2,3,3,2,1)
cov(x0,y0)
cov(x0+5,y0/10)
cov(x0^2,y0^2)

bcoef <- function(n) {
  gamma(n+1)/(gamma(0:n+1)*rev(gamma(0:n+1)))
}
bcoef(2)
bcoef(6)
bcoef(10)

probs <- function(p,d) {
  m <- 1-d
  q <- 1-p
  p1 <- m*p+d*p^2
  p2 <- 2*p*q*d
  p3 <- m*q+d*q^2
  c(p1,p2,p3)
}
probs(0.5,0.5)
probs(0.5,0.8)
probs(0.2,0.2)
p <- 0.2
d <- 0.2
probs(p,d)
sum(probs(p,d))

sqdist <- function(x,y) {
  n1 <- length(x)
  n2 <- length(y)
  xy <- matrix(0,n1,n2)
  for (i in 1:n1) {
    for (i in 1:n2) {
      xy[i,j] <- x[i]^2+y[j]^2
    }
  }
  xy
}
sqdist(1:10,1:10)
sqdist(1:4,1:6)

outer(1:4,1:6,function(x,y){x^2+y^2})

distance2 <- function(x,y) { x^2+y^2 }
outer(1:4,1:6,distance2)

or.ci <- function(tab) {
  or <- tab[1,1]*tab[2,2]/(tab[1,2]*tab[2,1])
  logor <- log(or)
  v <- 1/tab[1,1]+1/tab[2,1]+1/tab[1,2]+1/tab[2,2]
  bounds <- c(logor-1.96*sqrt(v),logor+1.96*sqrt(v))
  cat("odds ratio =",round(or,3)," 95% confidence bounds: ",round(exp(bounds),3),"\n")
}

f.tab <- matrix(c(178,79,1411,1486),2,2)
f.tab
or.ci(f.tab)

row1 <- c(24,24,16,16,25,15,40)
row2 <- c(10,8,8,6,25,10,30)
data <- rbind(row1,row2)
data
rsum <- apply(data,1,sum)
csum <- apply(data,2,sum)
n <- sum(data)
ex <- outer(rsum,csum)/n
round(ex,2)
x2 <- sum((data-ex)^2/ex)
df <- (nrow(data)-1)*(ncol(data)-1)
pvalue <- 1-pchisq(x2,df)
round(cbind(x2,df,pvalue),3)

chisq.test(data)

temp <- scan("ab.data")
data <- matrix(temp,2)
d <- data[1,]
id <- data[2,]
d1 <- d[id==1]
d1
d2 <- d[id==0]
d2
mdiff <- mean(d1)-mean(d2)
mdiff
n <- length(d1)
m <- length(d2)
N <- n+m
vp <- ((n-1)*var(d1)+(m-1)*var(d2))/(N-2)
vp
tstat <- mdiff/sqrt(vp*(1/n+1/m))
pvalue <- 2*(1-pt(abs(tstat),N-2))
round(cbind(tstat,pvalue),3)
### - R --
### t.test(d1,d2,var.equal=T)
t.test(d1,d2)
t.test(d1,d2,var.equal=F)
w <- sum(rank(c(d1,d2))[1:m])
ew <- n*(N+1)/2
v <- m*n*(N+1)/12
z <- (w-ew-0.5)/sqrt(v)
pvalue <- 2*(1-pnorm(abs(z)))
round(cbind(z,pvalue),3)
wilcox.test(d1,d2,exact=F)

x1 <- rep(c(1:4),3)
x2 <- rep(c(1,2,3),rep(4,3))
a <- 10
b1 <- 3
b2 <- -0.5
y <- a+b1*x1+b2*x2+rnorm(length(x1))
cbind(x1,x2,y)

lsfit(cbind(x1,x2),y)

otemp <- lsfit(cbind(x1,x2),y)

summary(otemp)

otemp$coef
b <- otemp$coef
b[2]
b
x1 <- c(1,1,4,4)
x2 <- c(1,4,1,4)
b[1]+b[2]*x1+b[3]*x2
otemp$intercept
otemp$residuals
sum(otemp$residuals^2)

temp <- scan("ttest.data")
dtemp <- t(matrix(temp,3))
d1 <- dtemp[1:25,]
d2 <- dtemp[26:63,]
n1 <- nrow(d1)
n2 <- nrow(d2)
k <- ncol(dtemp)
xbar1 <- apply(d1,2,mean)
xbar2 <- apply(d2,2,mean)
dbar <- xbar2-xbar1
round(cbind(xbar1,xbar2,dbar),3)
v <- ((n1-1)*var(d1)+(n2-1)*var(d2))/(n1+n2-2)
round(v,3)
t2 <- n1*n2*dbar%*%solve(v)%*%dbar/(n1+n2)
f <- (n1+n2-k-1)*t2/((n1+n2-2)*k)
pvalue <- 1-pf(f,ncol(dtemp),n1+n2-k-1)
cbind(f,pvalue)

### - R --
### temp <- length(system("ls"))
temp <- length(unix("ls"))

temp <- unix("wc -l <input.dat")
temp
numlines <- as.numeric(temp)
numlines
data <- matrix(scan("input.dat"),numlines,byrow=T)

### end of file 1.R
